/*
 * pichex.h
 *
 * Defines the interfaces to the PICHEX library.
 *
 * Revision history:
 *
 * 18-Jul-1996: V-0.0; created
 *
 * Copyright (C) 1996 David Tait.  All rights reserved.
 * Permission is granted to use, modify, or redistribute this software
 * so long as it is not sold or exploited for profit.
 *
 * THIS SOFTWARE IS PROVIDED AS IS AND WITHOUT WARRANTY OF ANY KIND,
 * EITHER EXPRESSED OR IMPLIED.
 *
 */

 #ifndef __PICHEX_H
 #define __PICHEX_H

 #include "hex.h"
 #ifdef LIBVERSION
 #undef LIBVERSION
 #endif
 #include "misc.h"

 int addcfg(FILE *ifp, FILE *ofp, char *cftxt);
 int addid(FILE *ifp, FILE *ofp, char *hexid[]);
 int cmphex(FILE *afp, FILE *bfp, int diffs[]);
 int combhex(FILE *pfp, FILE *dfp, FILE *ofp);
 int hex2jm(FILE *hfp, FILE *bfp);
 int hex2list(FILE *hfp, FILE *lfp);
 int jm2hex(FILE *bfp, FILE *hfp);
 int list2hex(FILE *lfp, FILE *hfp);
 int splithex(FILE *hfp, char *pfn, char *dfn, int origin);
 int swaphex(FILE *ifp, FILE *ofp);
 int whathex(FILE *hfp);

 #endif  /* __PICHEX_H */